<template>
  <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button
      type="primary"
      circle
      v-show="!editable"
      @click="editable = !editable"
      >编辑</el-button
    >
    <el-button type="primary" v-show="editable" @click="saveData"
      >确定</el-button
    >
  </div>
  <div id="printContent" ref="imageWrapper">
    <h3>打包工序生产质量记录</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime1 }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>

      <!-- <div class="title_form_input">
                  <span>生产线：</span>
                  <span>四线</span>
                </div> -->
    </div>
    <el-divider />
    <HJTABLE
      :SClist="ssList"
      :tableHeader="scHeader"
      :labelName="labelName.b1"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="ssList"
      :tableHeader="sc2Header"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="ssList"
      :tableHeader="sc3Header"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="SClist"
      :tableHeader="tableHeader"
      :labelName="labelName.b2"
      :editable="editable"
    ></HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { dabaoVoLast, save } from "@/api/DBapi";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
import { useRouter } from "vue-router";
import { headReport } from "@/api/head";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const router = useRouter();
    const tableHeader = reactive([
      {
        prop: "rdTime1",
        label: "时间",
        editable: false,
        type: "text",
      },
      {
        prop: "pihao",
        label: "批号",
        editable: false,
        type: "input",
      },
      {
        prop: "baohao",
        label: "包号",
        editable: false,
        type: "input",
      },
      {
        prop: "waiguan",
        label: "外观（四面）",
        editable: false,
        type: "text",
      },
      {
        prop: "chanraomoSj",
        label: "缠绕膜松紧度",
        editable: false,
        type: "input",
      },
      {
        prop: "dabaoSj",
        label: "打包带松紧度",
        editable: false,
        type: "input",
      },
    ]);
    const scHeader = reactive([
      {
        prop: "kongqiYl",
        label: "空气压力",
        editable: false,
        type: "text",
      },
      {
        prop: "dabaodai",
        label: "打包带厂家",
        editable: false,
        type: "input",
      },
      {
        prop: "dabaodaiGg",
        label: "规格",
        editable: false,
        type: "input",
      },
      {
        prop: "dabaodaiNum",
        label: "数量",
        editable: false,
        type: "text",
      },
    ]);
    const sc2Header = reactive([
      {
        prop: "chengpinBh",
        label: "成品包数",
        editable: false,
        type: "text",
      },
      {
        prop: "chanraomo",
        label: "打包带厂家",
        editable: false,
        type: "input",
      },
      {
        prop: "chanraomoGg",
        label: "规格",
        editable: false,
        type: "input",
      },
      {
        prop: "chanraomoNum",
        label: "数量",
        editable: false,
        type: "text",
      },
    ]);
    const sc3Header = reactive([
      {
        prop: "feipinTj",
        label: "废品统计",
        editable: false,
        type: "text",
      },
    ]);

    let tableData = reactive([]);

    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });
    let hanjiRdData = reactive({
      dabaoZhiliangRdList: {},
      dabaoRd: {},
    });
    let SClist = ref([]);
    let hjData = ref({});
    let ssList = ref([]);
    let sc35 = [];
    let sc70 = [];
    let labelName = {
      b1: "生产记录",

      b2: "质量记录",
      b3: "废品统计",
    };
    let editable = ref(false);

    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    const getListData = async () => {
      const data = await dabaoVoLast();
      parse(data);
    };
    function parse(data) {
      headData.head = data.data.head;
      headData.head.reportTime1 = headData.head.reportTime.substr(0, 10);

      SClist.value = data.data.dabaoZhiliangRdList;

      SClist.value.filter((item) => {
        if (item != null && item.rdTime != null)
          //这里用临时名称，不修改原始值，避免更新时，字段异常
          item.rdTime1 = item.rdTime.substr(11, 5);

        return item;
      });

      ssList.value = [data.data.dabaoRd];

      hjData.value = {
        ...headData.head,
        ...data.data.dabaoRd,
        t1: sc35.value,
        t2: sc70.value,
      };
    }
    //截图
    const saveData = async () => {
      editable = false;

      let data = {
        dabaoZhiliangRdList: SClist.value,
        dabaoRd: ssList.value[0],

        head: headData.head,
      };
      console.log("save data...", data);
      const dt = await save(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "打包工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("db.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象
        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,

          // table: hanjiRdData.hanjiRd,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "打包工序生产质量记录.docx");
      });
    }

    const getRouterData = async (req) => {
      console.log("req....", req);
      const data = await headReport(req);
      console.log("jbj router data.....", data);

      parse(data);
    };
    onMounted(() => {
      console.log("rrrrrrrrrrr", router.currentRoute.value.query);
      let head_id = router.currentRoute.value.query.id;
      let leixing = router.currentRoute.value.query.leixing;
      console.log("vue recv....", head_id, leixing);
      if (head_id == null) {
        getListData();
      } else {
        getRouterData({ head_id: head_id, leixing: leixing });
      }
    });
    return {
      getRouterData,
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      tableHeader,
      scHeader,
      sc2Header,
      sc3Header,
      getListData,
      headData,
      toImage,
      imageWrapper,
      SClist,
      ssList,
      exportWord,
      labelName,
      editable,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}
#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}
.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}
.title_form_input {
  font-size: 16px;
}
</style>
